/** This component provides on-demand logging to the javascript console. */


/*************** COMPONENT *************************/

function mtMsgObserver() {
  // allow direct access through javascript (so [data] member can be set)
  this.wrappedJSObject = this;
  this.consoleService = Components.classes['@mozilla.org/consoleservice;1']
    .getService(Components.interfaces.nsIConsoleService);
  //  this.logWindow = false;
}

mtMsgObserver.prototype = {

  //////// mtIMsgObserver Functions ////////////

  myDump: function (msg) {
    if (this.logWindow)
      this.logWindow.value += msg + "\n";
    else
      this.consoleService.logStringMessage(msg);
  },

  handleMsg: function (msg, severity) {
    var iface = Components.interfaces.mtIMsgObserver;
    if (severity == iface.MSG_SEVERITY_LOG)
      this.myDump(msg);
    if (severity == iface.MSG_SEVERITY_WARN)
      this.myDump("WARNING: " + msg);
    else if (severity == iface.MSG_SEVERITY_ERROR)
      this.myDump("ERROR: " + msg);
    else
      return Components.results.NS_ERROR_ILLEGAL_VALUE;
    return Components.results.NS_OK;
  },

  throwException: function (msg) {
    this.myDump("Error: " + msg);
    throw Components.results.NS_ERROR_FAILURE;
  },

  //////// Component Housekeeping //////////

  get value()       { return this.val; },
  set value(newval) { return this.val = newval; },
  QueryInterface : function (iid) {
    if (iid.equals(Components.interfaces.mtIMsgObserver) ||
	iid.equals(Components.interfaces.nsISupports))
      return this;

    Components.returnCode = Components.results.NS_ERROR_NO_INTERFACE;
    return null;
  },

}


/*************** MODULE *************************/

  var myModule = {
    registerSelf: function mod_regself(compMgr, fileSpec, location, type) {
      var compReg = compMgr.QueryInterface( Components.interfaces.nsIComponentRegistrar );
      compReg.registerFactoryLocation(this.myCID, 
				      "mtMsgObserver", 
				      this.myProgID,
				      fileSpec, location, type );
    },

    getClassObject: function (compMgr, cid, iid) {
      if (!cid.equals(this.myCID))
	throw Components.results.NS_ERROR_NO_INTERFACE;

      if (!iid.equals(Components.interfaces.nsIFactory))
	throw Components.results.NS_ERROR_NOT_IMPLEMENTED;

      return this.myFactory;
    },

    myCID:    Components.ID('{10EFE9AC-CDE5-4104-807B-786C2B43FD62}'),
    myProgID: '@pdx.edu/moztorch/mtMsgObserver;1',


    /* Factory Object */
    myFactory : {
      /* Construct instance of specified interface. */
      createInstance: function (outer, iid) {
	if (outer != null)
	  throw Components.results.NS_ERROR_NO_AGGREGATION;

	return (new mtMsgObserver()).QueryInterface(iid);
      }
    },

    canUnload : function(compMgr) {
      return true;
    }

  };


// NSGetModule: Return the nsIModule object.
function NSGetModule(compMgr, fileSpec) {
  return myModule;
}




function dump_bk(s) {

  var msgField = document.getElementById("document");
  msgField.value += s + "\n";
  return;


  var consoleService = Components.classes['@mozilla.org/consoleservice;1']
    .getService(Components.interfaces.nsIConsoleService);
  consoleService.logStringMessage("[mtMsgObserver] " + s);
}
  


